{

ultimate ftn bases processing
(c) 2000 by raVen

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rBases;
interface
Uses Objects, rAbs;
{}
type
 pFtnBases = ^tFtnBases;
 tFtnBases = object(tSortedCollection)

  constructor Init;
  destructor  Done; virtual;

  function    Compare(Key1,Key2: Pointer): Integer; virtual;

  procedure   StoreBase(aBaseFileName: String);
  procedure   StoreAll;

  function    GetBaseStatus(aBaseFileName: String): tBaseStatus;
  function    GetMsgCount(aBaseFileName: String): Longint;

  function    GetSourceAddress(aBaseFileName: String): String;
  function    GetDestinationAddress(aBaseFileName: String): String;
  function    GetPassWord(aBaseFileName: String): String;
  procedure   SetSourceAddress(aBaseFileName, s: String);
  procedure   SetDestinationAddress(aBaseFileName, s: String);
  procedure   SetPassword(aBaseFileName, s: String);

  function    ExistMsg(aBaseFileName: String; Number: Longint): Boolean;
  function    DeleteMsg(aBaseFileName: String; Number: LongInt): Byte;

  function    LoadMsg(aBaseFileName: String; var Msg: tAbsMsg; Number: Longint): Byte;
  function    SaveMsg(aBaseFileName: String; var Msg: tAbsMsg; Number: Longint): Byte;

 priVate
  function    GetBaseByName(aBaseFileName: String; var i: Integer): pAbsBase;
 end;
{}
implementation
Uses rObjects, rStrings, rOpen, rJam, rSquish, rFidoMsg;
{}
constructor tFtnBases.Init;
 begin
  inherited Init(16,16);
 end;
{}
destructor  tFtnBases.Done;
 begin
  StoreAll;
  inherited Done;
 end;
{}
function tFtnBases.Compare;
 var
  s1,s2: String;
  q1: pAbsBase absolute key1;
  q2: pAbsBase absolute key2;
 begin

  s1:=GetPS(q1^.BaseFileName);
  s2:=GetPS(q2^.BaseFileName);

  if (TypeOf(q1^)=TypeOf(tJamBase)) then s1:=JamLetter+s1 else
  if (TypeOf(q1^)=TypeOf(tSquishBase)) then s1:=SquLetter+s1 else
  if (TypeOf(q1^)=TypeOf(tPktBase)) then s1:=PktLetter+s1 else
  if (TypeOf(q1^)=TypeOf(tMsgBase)) then s1:=MsgLetter+s1;

  if (TypeOf(q2^)=TypeOf(tJamBase)) then s2:=JamLetter+s2 else
  if (TypeOf(q2^)=TypeOf(tSquishBase)) then s2:=SquLetter+s2 else
  if (TypeOf(q2^)=TypeOf(tPktBase)) then s2:=PktLetter+s2 else
  if (TypeOf(q2^)=TypeOf(tMsgBase)) then s2:=MsgLetter+s2;

  if (s1>s2) then Compare:=-1 else
   if (s1=s2) then Compare:=0 else
    if (s1<s2) then Compare:=1;

 end;
{}
procedure   tFtnBases.StoreBase;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  AtFree(i);
 end;
{}
procedure   tFtnBases.StoreAll;
 begin
  FreeAll;
 end;
{}
function    tFtnBases.GetBaseStatus;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  GetBaseStatus:=bsClosed;
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  GetBaseStatus:=Base^.BaseStatus;
 end;
{}
function    tFtnBases.GetMsgCount;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  GetMsgCount:=-1;
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  GetMsgCount:=BAse^.Count;
 end;
{}
function    tFtnBases.GetSourceAddress;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  GetSourceAddress:='';
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  GetSourceAddress:=Base^.GetSourceAddress;
 end;
{}
function    tFtnBases.GetDestinationAddress;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  GetDestinationAddress:='';
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  GetDestinationAddress:=Base^.GetDestinationAddress;
 end;
{}
function    tFtnBases.GetPassWord;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  GetPassWord:='';
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  GetPassWord:=Base^.GetPassWord;
 end;
{}
procedure   tFtnBases.SetSourceAddress;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  Base^.SetSourceAddress(s);
 end;
{}
procedure   tFtnBases.SetDestinationAddress;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  Base^.SetDestinationAddress(s);
 end;
{}
procedure   tFtnBases.SetPassWord;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  Base^.SetPassWord(s);
 end;
{}
function    tFtnBases.ExistMsg;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  ExistMsg:=False;
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  ExistMsg:=Base^.ExistMsg(Number);
 end;
{}
function    tFtnBases.DeleteMsg;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  DeleteMsg:=1;
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  DeleteMsg:=Base^.DeleteMsg(Number);
 end;
{}
function    tFtnBases.LoadMsg;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  LoadMsg:=1;
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  LoadMsg:=Base^.LoadMsg(Msg,Number);
 end;
{}
function    tFtnBases.SaveMsg;
 var
  Base: pAbsBase;
  i: Integer;
 begin
  SaveMsg:=1;
  Base:=GetBaseByName(aBaseFileName,i);
  if (Base=nil) or (i<0) then exit;
  SaveMsg:=Base^.SaveMsg(Msg,Number);
 end;
{}
function    tFtnBases.GetBaseByName;
 var
  NewBase,TempBase: pAbsBase;
 begin
  GetBaseByName:=nil;
  i:=-1;
  TempBase:=OpenOrCreateBase(aBaseFileName,stDenyNone);
  if Search(TempBase,i) then
   begin
    GetBaseByName:=At(i);
    DisposeObj(TempBase);
   end
  else
   begin
    NewBase:=TempBase;
    if (NewBase<>nil) then
     begin
      Insert(NewBase);
      GetBaseByName:=NewBase;
      i:=Count-1;
     end;
   end;
 end;
{}
end.
