{

raVen's common functions
(c) 1995-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

13/12/99   # DelDir(...Recurse: Boolean)
05/01/00   + MoveFile()
            DateStr() y2k fix
13/01/00   + StrRCopy: StrLCopy analog, but does not check zero terminations
26/01/00   # CopyFile: keep date/time and attributes
06/02/00   + RemoveBackSlash(DirName: String): String;
           + Reverse(s: String): String;
           + Asc1Reverse(var s: Asciiz);
           + AscUpcase(var A, B : Asciiz);
           + AscLocase(var A, B : Asciiz);
02/04/00   - Hex2Dec
           - Bin2Dec
           + FromDec(Num: Longint; Base: Integer; LeadZero: Byte): String;
           + ToDec(Num: String; Base: Integer): Longint;
22/04/00    MkTree
30/04/00   - garbage units
01/05/00   + CompName by Eugene Roshal (extended dos wildcards)
27/05/00   - OpAsciiz
           + rAsciiz, i.e. Asciiz -> pChar
01/06/00   -   ⮢  㤠 OpAsciiz 모. ⥯ 
              ᯮ pChar
           - OpString ⮦ 모. 㦭 㭪樨 ७ᥭ  rStrings
15/06/00    FindFiles
23/08/00   + UUESize  (thanx to
           + UUELines           Alexnader Ostapchuk, 2:463/419)

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
unit rCommon;
interface
{}
const
{( monitor states )}
 MonOn      = 00;
 MonStandBy = 01;
 MonSuspend = 02;
 MonOff     = 04;
 MonReduced = 08; {reduced On (for flat screens)}
 MemFucked: Longint = 0;
{( vp's message )}
{$IfDef VirtualPascal}
 ErrorMsg: pChar = ^G^G^G#13#10'not implemented under this platform!';
{$EndIf}
{}
type
 tFileProc = procedure(x: String);
{( common stuff )}
 function    Timer: Longint;
 procedure   Fuck;
{( numeric operations )}
 function    LeadZero(What,ZeroCount: Longint) : String;
 function    LeadZeroS(What: String; ZeroCount: Longint) : String;
 function    PoWer(Base,Exponent: Real): Real;
 function    rnd(a,b: Real): Real;
{( console works )}
 procedure   SetRGBColor(color,r,g,b: byte);
 procedure   GetRGBColor(Color: byte; var r,g,b: byte);
 procedure   MonState(State:byte);
 function    GetBlink: boolean;
 procedure   SetBlink(OffOn: boolean);
 procedure   Str2Kbrd(S:String);
{( dos works )}
 function    MkTree(Pth: String): Boolean;
 function    DiskLetters: String;
 function    Writeable(Drive: Char): Boolean;
 function    DExist(st_Dir : String) : Boolean;
 procedure   DelDir(Path: String; Recurse: Boolean);
 function    CopyDir(SourceDir,DestDir: String; Recurse: Boolean): Byte;
 function    HideDir(DirName: String; Exist: Boolean): Boolean;
 function    ExeLen(Name: String): Longint;
 function    SizeOfFile(fn: String): Longint;
 procedure   FindFiles(DirPath: String; Mask: String; Recurse: Boolean; FileDoer: tFileProc);
 procedure   CopyFile(From,Too: String; Add: Boolean);
 procedure   MoveFile(SrcPath, DstPath: String);
 procedure   KillFile(FileName: String);
 function    Exist(FileName: String): boolean;
 procedure   ZeroFile(FN: String);
 function    GetMSGID: String;
 function    CalcNotExistFileName(Dir,Ext: String): String;
 function    GetTempFileName: String;
{}
implementation
Uses Dos, Strings, rStrings{$IfDef VirtualPascal},VPUtils, VPSysLow{$EndIf};
{( common stuff )}
function    Timer: Longint;
{$IFDEF VirtualPascal}
 begin
  Timer:=SysSysMsCount;
 end;
{$ENDIF}
{$IFDEF Ver70}
 assembler;
  asm
   push    ds              { save caller's data segment }
   mov     ds, seg0040     {  access ticker counter }
   mov     bx, 6ch         { offset of ticker counter in segm.}
   mov     dx, 43h         { timer chip control port }
   mov     al, 4           { freeze timer 0 }
   pushf                   { save caller's int flag setting }
   cli                     { make reading counter an atomic operation}
   mov     di, ds:[bx]     { read bios ticker counter }
   mov     cx, ds:[bx+2]
   sti                     { enable update of ticker counter }
   out     dx, al          { latch timer 0 }
   cli                     { make reading counter an atomic operation}
   mov     si, ds:[bx]     { read bios ticker counter }
   mov     bx, ds:[bx+2]
   in      al, 40h         { read latched timer 0 lo-byte }
   mov     ah, al          { save lo-byte }
   in      al, 40h         { read latched timer 0 hi-byte }
   popf                    { restore caller's int flag }
   xchg    al, ah          { correct order of hi and lo }
   cmp     di, si          { ticker counter updated ? }
   je      @no_update      { no }
   or      ax, ax          { update before timer freeze ? }
   jns     @no_update      { no }
   mov     di, si          { use second }
   mov     cx, bx          {  ticker counter }
@no_update:  not     ax              { counter counts down }
   mov     bx, 36edh       { load multiplier }
   mul     bx              { w1 * m }
   mov     si, dx          { save w1 * m (hi) }
   mov     ax, bx          { get m }
   mul     di              { w2 * m }
   xchg    bx, ax          { ax = m, bx = w2 * m (lo) }
   mov     di, dx          { di = w2 * m (hi) }
   add     bx, si          { accumulate }
   adc     di, 0           {  result }
   xor     si, si          { load zero }
   mul     cx              { w3 * m }
   add     ax, di          { accumulate }
   adc     dx, si          {  result in dx:ax:bx }
   mov     dh, dl          { move result }
   mov     dl, ah          {  from dl:ax:bx }
   mov     ah, al          {   to }
   mov     al, bh          {    dx:ax:bh }
   mov     di, dx          { save result }
   mov     cx, ax          {  in di:cx }
   mov     ax, 25110       { calculate correction }
   mul     dx              {  factor }
   sub     cx, dx          { subtract correction }
   sbb     di, si          {  factor }
   xchg    ax, cx          { result back }
   mov     dx, di          {  to dx:ax }
   pop     ds              { restore caller's data segment }
  end;
{$ENDIF}
{}
procedure   Fuck;
 begin
{$IfDef Ver70}
  inline($FA/$EB/$FE);    { ⤠}
  inline($F0/$0F/$C7/$C8) { }
{$EndIf}
 end;
{( numeric operations )}
function    LeadZero(What,ZeroCount: Longint) : String;
 var
  s: String;
 begin
  Str(What,s);
  if Length(s)>=ZeroCount then Delete(s,1,Abs(ZeroCount-Length(s)));
  s:=LeftPadCh(s,Digits[1],ZeroCount);
  LeadZero:=s;
 end;
{}
function    LeadZeroS(What: String; ZeroCount: Longint) : String;
 begin
  if Length(What)>ZeroCount then Delete(What,ZeroCount,Length(What));
  LeadZeroS:=LeftPadCh(What,Digits[1],ZeroCount);
 end;
{}
function    Power(Base,Exponent: Real): Real;
 var
  Tmp: Real;
 begin
  Power:=0;
  if Int(Exponent/2)=Exponent/2 then Base:=Abs(Base);
  if Exponent=0 then
   begin
    Power:=1;
    Exit
   end;
  if Base=0 then
   begin
    power:=0;
    exit
   end;
  if Base>0 then
   begin
     Tmp:=Exp((Abs(Exponent))*Ln(Base));
    if Exponent>0 then
     begin
      power:=Tmp;
      exit
     end;
    if Exponent<0 then
     begin
      power:=1/Tmp;
      exit
     end;
   end;
  if Base<0 then
   begin
    Tmp :=Exp((Abs(Exponent))*Ln(Abs(Base)));
    if Exponent>0 then
     begin
      power:=-Tmp;
      exit
     end;
    if Exponent<0 then
     begin
      power:=-1/Tmp;
      exit
     end;
   end;
 end;
{}
function rnd(a,b: Real): Real;
 begin
  rnd:=(random(32767)/32767.0)*(B-A)+A;
 end;
{(console works )}
procedure   SetRGBColor(Color,r,g,b: Byte);
{$IfDef Ver70}
assembler;
 asm
  mov dx,3C8h
  mov al,color
  out dx,al
  inc dx
  mov al,r
  out dx,al
  mov al,g
  out dx,al
  mov al,b
  out dx,al
 end;
{$EndIf}
{$IfDef VirtualPascal}
 const
  SetRGBCom: pChar = #$BA#$C8#$03#$B0#$0A#$EE#$42#$B0#$0A#$EE#$B0#$0A#$EE#$B0#$0A#$EE#$C3;
  fName: pChar = 'SetRGB.COM';
 var
  f: file;
 begin
  SetRGBCom[4]:=Char(Color);
  SetRGBCom[8]:=Char(r);
  SetRGBCom[11]:=Char(g);
  SetRGBCom[14]:=Char(b);
  Assign(f,StrPas(fName)); Rewrite(f,1);
  BlockWrite(f,SetRGBCom^,17); Close(f);
  Exec(StrPas(fName),'');
  Erase(f);
 end;
{$EndIf}
{}
procedure   GetRGBColor(Color: Byte; var r,g,b: Byte);
{$IfDef Ver70}
assembler;
 asm
  mov dx,3C7h
  mov al,color
  out dx,al
  add dx,2
  in al,dx
  les di,r
  stosb
  in al,dx
  les di,g
  stosb
  in al,dx
  les di,b
  stosb
end;
{$EndIf}
{$IfDef VirtualPascal}
 begin
  WriteLn(ErrorMsg);
  Halt(133);
 end;
{$EndIf}
{}
procedure   MonState(State: System.Byte);
{$IfDef Ver70}
assembler;
 asm
  mov     ax,04F10h
  mov     bl,1
  mov     bh,State
  int     10h
 end;
{$EndIf}
{$IfDef VirtualPascal}
 const
  MonState: pChar = #$B8#$10#$4F#$B3#$01#$B7#$00#$CD#$10#$C3;
  fName: pChar = 'MonState.COM';
 var
  f: file;
 begin
  MonState[6]:=Char(State);
  Assign(f,StrPas(fName)); Rewrite(f,1);
  BlockWrite(f,MonState^,10); Close(f);
  Exec(StrPas(fName),'');
  Erase(f);
 end;
{$EndIf}
{}
function    GetBLink: Boolean;
{$IfDef Ver70}
assembler;
 asm
  xor     ax,ax
  mov     es,ax
  mov     al,es:[465h]
  and     al,20h
  mov     cl,5
  shr     al,cl
 end;
{$EndIf}
{$IfDef VirtualPascal}
 begin
  WriteLn(ErrorMsg);
  Halt(133);
 end;
{$EndIf}
{}
procedure   SetBLink(OffOn: Boolean);
{$IfDef Ver70}
assembler;
 asm
  push ax
  mov ax,$1003
  mov bl,offon
  int $10
  pop ax
 end;
{$EndIf}
{$IfDef VirtualPascal}
 const
  BlinkCom: pChar = #$B8#$03#$10#$B3#$00#$CD#$10#$C3;
  fName: pChar = 'SetBlink.COM';
 var
  f: file;
 begin
  if OffOn then BlinkCom[4]:=#1 else BlinkCom[4]:=zr;
  Assign(f,StrPas(fName)); Rewrite(f,1);
  BlockWrite(f,BlinkCom^,8); Close(f);
  Exec(StrPas(fName),'');
  Erase(f);
 end;
{$EndIf}
{}
{}
procedure   Str2kbrd(S: String);
{$IfDef Ver70}
 var
  Regs: Registers;
  x: Byte;
  BufferFull: Boolean;
 begin
  Inc(S[0]);
  S[Byte(S[0])]:=#13;
  x:=1;
  repeat
   Regs.AH:=$05;
   Regs.CL:=Byte(S[x]);
   Intr($16,Regs);
   BufferFull:=Boolean(Regs.AL);
   Inc(x);
  until BufferFull or (x>Byte(S[0]));
 end;
{$EndIf}
{$IfDef VirtualPascal}
 begin
  WriteLn(ErrorMsg);
  Halt(133);
 end;
{$EndIf}
{( dos works )}
function    MkTree(Pth: String): Boolean;
 var
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
  s,np: String;
 begin
  MkTree:=false;
  FSplit(Pth,Dir,Name,Ext);
  Dir:=AddBackSlash(Dir);
  np:='';
  repeat
   s:=Copy(Dir,1,Pos(BackSlash,Dir)-1);
   Delete(Dir,1,Pos(BackSlash,Dir));
   np:=np+s;
   if Length(np)=2 then if np[2]=DualPoint then
    begin
     np:=np+BackSlash;
     Continue;
    end;
   if (not DExist(RemoveBackSlash(np))) then MkDir(np);
   if IOResult<>0 then exit;
   np:=np+BackSlash;
  until s='';
  MkTree:=True;
 end;
{}
function    DiskLetters: String;
 var
  Disks: String;
  i: byte;
 begin
  Disks:= '';
  for i:=2 to 26 do if DiskFree(i)>0 then Disks:= Disks+chr(i+64);
  DiskLetters:=Disks;
 end;
{}
function    Writeable(Drive: Char): Boolean;
 var
  fn:File;
 begin
  Assign(fn,drive+':\tester.tmp');
  ReWrite(fn);
  Close(fn);
  Writeable:=IOResult=0;
  KillFile(Drive+':\tester.tmp');
 end;
{}
function    DExist(st_Dir: String): Boolean;
 var
  WO_FAttr: Word;
  fi_Temp: file;
 begin
  st_Dir:=RemoveBackSlash(st_Dir);
  if Pos('.',st_Dir)=0 then st_Dir:=st_Dir+'.';
  Assign(fi_Temp,(st_Dir));
  GetfAttr(fi_Temp,WO_FAttr);
  if (DosError <> 0) then DExist:=False
  else DExist:=((WO_FAttr and Directory) <> 0);
 end;
{}
procedure   DelDir(Path: String; Recurse: Boolean);
 var
  FileInfo: SearchRec;
{$IfDef VirtualPascal}
  FileInfo1: SearchRec;
{$EndIf}
  f: File;
  path2: String;
 begin
  Dos.FindFirst(Path+'\*.*',AnyFile,FileInfo);
  while DosError = 0 do
   begin
    if (FileInfo.Name[1]<>'.') and (FileInfo.Attr<>VolumeId) then
    if ((FileInfo.Attr and Directory)=Directory) then
     begin
      Path2:=Path+BackSlash+FileInfo.Name;
      if Recurse then DelDir(path2,Recurse);
     end
    else if ((FileInfo.Attr and VolumeID)<>VolumeID) then
     begin
      Assign(f,Path+BackSlash+FileInfo.Name);
      SetFAttr(f,Archive);
      Erase(f);
     end;
    Dos.FindNext(FileInfo);
   end;
  if (DosError=18) and (Path[Length(Path)]<>BackSlash) and not ((Length(Path)=2) and (Path[2]=DualPoint)) then
   begin
{$IfDef VirtualPascal}
    FileInfo1:=FileInfo;
    Dos.FindClose(FileInfo);
{$EndIf}
    RmDir(Path);
{$IfDef VirtualPascal}
    Dos.FindFirst(Path+'\*.*',AnyFile,FileInfo);
    while (FileInfo.Name<>FileInfo1.Name) do Dos.FindNext(FileInfo);
{$EndIf}
   end;
{$IfDef VirtualPascal}
  Dos.FindClose(FileInfo);
{$EndIf}
 end;
{}
function    CopyDir(SourceDir,DestDir: String; Recurse: Boolean): Byte;
 procedure SubCopy(Source: String);
  var
   sr: SearchRec;
   Dest: String;
  begin
   Dos.FindFirst(Source+'*.*',AnyFile,sr);
   if UpStr(SourceDir)<>UpStr(Source)
   then Dest:=AddBackSlash(DestDir+Copy(Source,Length(SourceDir)+1,Length(Source)))
   else Dest:=AddBackSlash(DestDir);
   if MkTree(Dest) then while (DosError=0) do
    begin
     if (sr.Attr and (VolumeID+Directory))=0 then CopyFile(Source+sr.Name,Dest+sr.Name,false);
     Dos.FindNext(sr);
    end;
{$IfDef VirtualPascal}
   Dos.FindClose(sr);
{$EndIf}
   if Recurse then
    begin
     Dos.FindFirst(Concat(Source,'*.*'),AnyFile,sr);
     while (DosError=0) do
      begin
       while (DosError=0) and (sr.Name[1]='.') do Dos.FindNext(sr);
       if ((sr.Attr and Directory)=Directory) and (sr.Name[1]<>'.') then SubCopy(Concat(Source,sr.Name,BackSlash));
       Dos.FindNext(sr);
      end;
    end;
{$IfDef VirtualPascal}
   Dos.FindClose(sr);
{$EndIf}
  end;
 begin
  CopyDir:=1;
  SourceDir:=AddBackSlash(SourceDir);
  DestDir:=AddBackSlash(DestDir);
  if not DExist(SourceDir) then exit;
  if not MkTree(DestDir) then exit;
  if UpStr(SourceDir)=UpStr(DestDir) then exit;
  SubCopy(SourceDir);
  CopyDir:=0;
 end;
{}
function    HideDir(DirName: String; Exist: Boolean):Boolean;
{$IfDef Ver70}
 var
  Regs: Registers;
 begin
  FillChar(Regs,SizeOf(Regs),0);
  DirName:=DirName+zr;
  Regs.ah:=$43;
  Regs.al:=$01;
  Regs.ds:=Seg(DirName[1]);
  Regs.dx:=Ofs(DirName[1]);
  if Exist then Regs.cx:=1 else Regs.cx:=2;
  Intr($21,Regs);
  HideDir:=not Regs.Flags and FCArry<>0
end;
{$EndIf}
{$IfDef VirtualPascal}
 begin
  WriteLn(ErrorMsg);
  Halt(133);
 end;
{$EndIf}
{}
function    ExeLen(Name: String): Longint;
 var
  len: Longint;
  i: Word;
  f: file;
 begin
  Assign(f,Name);
  Reset(f,1);
  Seek(f,2);
  BlockRead(f,i,2);
  Len:=i;
  BlockRead(f,i,2);
  Len:=Len+Pred(i)*512;
  Close(f);
  ExeLen:=Len;
 end;
{}
function    SizeOfFile(fn: String): Longint;
 var
  di: SearchRec;
 begin
  Dos.FindFirst(fn, AnyFile, di);
  if DosError<>0 then SizeOfFile:=-1 else SizeOfFile:=di.Size;
{$IfDef VirtualPascal}
  Dos.FindClose(di);
{$EndIf}
 end;
{}
procedure   CopyFile(From,Too: String; Add: Boolean);
 type
  TBuf=array[1..$FFFF] of Char;
 var
  FromF,ToF: file;
  NumRead,NumWrItten: Word;
  Buf: ^TBuf;
  Time: Longint;
  Attr: Word;
 begin
  if Not Exist(From) then exit;
  if UpStr(From)=UpStr(Too) then exit;
  Assign(FromF,From);
  GetFTime(FromF,Time);
  GetFAttr(FromF,Attr);
  SetFAttr(FromF,Archive);
  Reset(FromF,1);
  Assign(ToF,Too);
  if Add then Reset(ToF,1);
  if ((IOResult<>0) or (not Add)) then ReWrite(ToF,1);
  Seek(Tof,FileSize(Tof));
  New(buf);
  repeat
   BlockRead(FromF,Buf^,SizeOf(Buf^),NumRead);
   BlockWrite(ToF,Buf^,NumRead,NumWrItten);
  until (NumRead = 0) or (NumWritten <> NumRead);
  Dispose(buf);
  Close(FromF);
  Close(ToF);
  SetFTime(ToF,Time);
  SetFAttr(ToF,Attr);
  SetFAttr(FromF,Attr);
 end;
{}
procedure MoveFile(SrcPath, DstPath: String);
 var
  SrcDir: String;
  DstDir: String;
  f: File;
 begin
  if not Exist(SrcPath) then exit;
  if UpStr(SrcPath)=UpStr(DstPath) then exit;
  SrcDir:=AddBackSlash(JustPathName(SrcPath));
  DstDir:=AddBackSlash(JustPathName(DstPath));
  SrcPath:=JustFileName(SrcPath);
  DstPath:=JustFileName(DstPath);
  if not MkTree(DstDir) then exit;
  if SrcDir='' then
   begin
    GetDir(0,SrcDir);
    SrcDir:=SrcDir+BackSlash;
   end;
  if DstDir='' then
   begin
    GetDir(0,DstDir);
    DstDir:=DstDir+BackSlash;
   end;
  SrcDir:=AddBackSlash(JustPathName(SrcDir));
  DstDir:=AddBackSlash(JustPathName(DstDir));
  if UpCase(SrcDir[1])=UpCase(DstDir[1]) then
   begin
    Assign(f,SrcDir+SrcPath);
    KillFile(DstDir+DstPath);
    Rename(f,DstDir+DstPath);
   end
  else
   begin
    CopyFile(SrcDir+SrcPath,DstDir+DstPath,false);
    KillFile(SrcDir+SrcPath);
   end;
 end;
{}
procedure   FindFiles(DirPath: String; Mask: String; Recurse: Boolean; FileDoer: tFileProc);
 procedure SubVisit(const DirPath: String);
  var
   sr: SearchRec;
  begin
   Dos.FindFirst(Concat(DirPath,Mask),AnyFile,sr);
   while (DosError=0) do
    begin
     if (sr.Attr and (VolumeID+Directory))=0 then FileDoer(Concat(DirPath,sr.Name));
     Dos.FindNext(sr);
    end;
{$IfDef VirtualPascal}
   Dos.FindClose(sr);
{$EndIf}
   if Recurse then
    begin
     Dos.FindFirst(Concat(DirPath,x_x),AnyFile,sr);
     while (DosError=0) and ((sr.Name=Point) or (sr.Name=Point+Point)) do Dos.FindNext(sr);
     while (DosError=0) do
      begin
       if ((sr.Attr and Directory)=Directory) then SubVisit(DirPath+sr.Name+BackSlash);
       Dos.FindNext(sr);
      end;
    end;
{$IfDef VirtualPascal}
   Dos.FindClose(sr);
{$EndIf}
  end;
 begin
  if Mask='' then Mask:=JustFileName(DirPath);
  DirPath:=AddBackSlash(JustPathName(DirPath));
  SubVIsIt(DirPath);
 end;
{}
procedure   KillFile(FileName: String);
{$IfDef Ver70}
assembler;
 var
  pathbuffer: array[0..78] of char;
 asm
  push ds
  cld
  mov ax,[word ptr filename+2]
  mov si,[word ptr filename]
  lea di,pathbuffer
  mov dx,di
  mov ds,ax
  mov bx,ss
  mov es,bx
  lodsb
  xor ah,ah
  mov cx,ax
  cmp cl,79
  jbe @@movethem
  mov cl,79
 @@movethem:
  shr cx,1
  jnc @@dowords
  movsb
 @@dowords:
  rep movsw
  mov [byte ptr es:di],0h
  mov ax,es
  mov ds,ax
  mov ah,41h
  mov cl,0
  int 21h
  pop ds
 end;
{$EndIf}
{$IfDef VirtualPascal}
 var
  f: file;
 begin
  if not Exist(FileName) then exit;
  Assign(f,FileName); Erase(f);
 end;
{$EndIf}
{}
function    Exist(FileName: String): Boolean;
 var
  F: File;
  A: Word;
 begin
  Assign(F, FileName);
  GetFAttr(F,A);
  Exist:=(DosError=0) and (a and Directory<>Directory);
 end;
{}
procedure   ZeroFile(fn: String);
 var
  F: Text;
 begin
  Assign(F,FN);
  ReWrite(F);
  if IOResult=0 then Close(F);
 end;
{}
function GetMSGID: String;
 var
  stamp: Longint;
  stampW: record
   L,H: System.Word
  end absolute stamp;
  Year,Month,Day,Dow,Hour,Min,Sec,Sec100: Word;
  q: DateTime;
 begin
  Dos.GetDate(Year,Month,Day,Dow);
  GetTime(Hour,Min,Sec,Sec100);
  Stamp:=LongInt(Year)*365*24*60*60;
  Stamp:=Stamp+LongInt(Month)*30*24*60*60;
  Stamp:=Stamp+LongInt(Day)*24*60*60;
  Stamp:=Stamp+LongInt(Hour)*60*60;
  Stamp:=Stamp+LongInt(Min)*60;
  stamp:=stamp+Longint(Sec);
  stamp:=(stamp shl 7) or (Sec100 and $7F);
  Stamp:=Stamp+Random(65535);
  GetMsgID :=
  Digits[1+Hi(stampW.H) shr 4] +
  Digits[1+Hi(StampW.H) and $F] +
  Digits[1+Lo(StampW.H) shr 4] +
  Digits[1+Lo(StampW.H) and $F] +
  Digits[1+Hi(StampW.L) shr 4] +
  Digits[1+Hi(StampW.L) and $F] +
  Digits[1+Lo(StampW.L) shr 4] +
  Digits[1+Lo(StampW.L) and $F];
 end;
{}
function    CalcNotExistFileName(Dir,Ext: String): String;
 var
  s: String;
  x: LongInt;
 begin
  if DExist(Dir) then s:=AddBackSlash(Dir) else s:='';
  if Ext[1]<>'.' then Ext:='.'+ext;
  repeat
   s:=GetMsgId;
   CalcNotExistFileName:=Dir+s+Ext;
  until not Exist(Dir+s+Ext);
 end;
{}
function GetTempFileName: String;
 var
  ext,dir,s: String;
  x: LongInt;
 begin
  dir:=AddBackSlash(GetEnv('TEMP'));
  ext:='.tmp';
  if MkTree(Dir) then s:=AddBackSlash(Dir) else s:='';
  repeat
   s:=GetMsgId;
   GetTempFileName:=Dir+s+Ext;
  until not Exist(Dir+s+Ext);
 end;
{}
var
 FirstAvail: Longint;
 OldExitProc: Pointer;
{$IfDef Ver70}
 OldInt1Ch: Pointer;
{$EndIf}
{$IfDef VirtualPascal}
 UpdateTID: Longint;
{}
function UpDateMemUsed(p: Pointer): Longint;
 begin
  repeat
   MemFucked:=MemUsed-FirstAvail;
   SysCtrlSleep(55);
  until false;
 end;
{$EndIf}
{$IfDef Ver70}
procedure UpDateMemFucked; interrupt;
 begin
  MemFucked:=FirstAvail-MemAvail;
{  inline($9C);
  asm call OldInt1Ch end;}
 end;
{$EndIf}
{}
procedure NewExitProc;
 begin
{$IfDef Ver70}
  SetIntVec($1C,OldInt1Ch);
{$EndIf}
{$IfDef VirtualPascal}
  KillThread(UpdateTID);
{$EndIf}
  ExitProc:=OldExitProc;
 end;
{}
begin
 OldExitProc:=ExitProc;
 ExitProc:=@NewExitProc;
{$IfDef Ver70}
 FirstAvail:=MemAvail;
 GetIntVec($1C,OldInt1Ch);
 SetIntVec($1C,@UpDateMemFucked);
{$EndIf}
{$IfDef VirtualPascal}
 FirstAvail:=MemUsed;
 UpDateTid:=VPBeginThread(UpDateMemUsed,1024,nil);
{$EndIf}
 asm
  jmp @lbl;
  db 0dh,0ah,' Victoria - rulez!',0dh,0ah
  @lbl:
 end;
end.
